<? 
  #  This program is free software; you can redistribute it and/or modify
  #  it under the terms of the GNU General Public License as published by
  #  the Free Software Foundation; version 2 of the License.
  #
  #  This program is distributed in the hope that it will be useful,
  #  but WITHOUT ANY WARRANTY; without even the implied warranty of
  #  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  #  GNU General Public License for more details.
  #
  #  You should have received a copy of the GNU General Public License
  #  along with this program; if not, write to the Free Software
  #  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

  # $Id: ce_mod_postgres.inc,v 1.19 2009-11-25 00:29:22 peter Exp $

function ce_mod_postgres(&$item,&$vars)
{
  global $HTTP_SERVER_VARS;
  global $ce_output_ok;
  global $HTTP_GET_VARS;
  global $HTTP_POST_VARS;
  global $ce_is_authenticated;

  $ce_output_ok=FALSE;

  ce_debug(30,"<!-- ce_mod_postgres(item,vars) called -->\n",__FILE__,__LINE__);

  $pg_id=ce_get_cgi_var("pg_id") ;
  if( preg_match( '/[!"$%&\/\\()=;:.,\*+\'#]/' , $pg_id ) )
    { ce_error("Invalid character in id",NULL,__FILE__,__LINE__) ;
      return ;  }

  $pg_order_by=ce_get_cgi_var("pg_order_by") ;
  if( preg_match( '/[!"$%&\/\\()=;:.\*+\'#]/' , $pg_order_by ) )
    { ce_error("Invalid character in order column",NULL,__FILE__,__LINE__) ;
      return ;  }

  $pg_fields=ce_get_cgi_var("pg_fields") ;
  if( preg_match( '/[!"$%&\/\\()=;:.\*+\'#]/' , $pg_fields ) )
    { ce_error("Invalid character in order column",NULL,__FILE__,__LINE__) ;
      return ;  }

  reset ($HTTP_POST_VARS);
  while (list ($key, $val) = each ($HTTP_POST_VARS)) {
    if ( 'pg_var_' == substr($key, 0, 7) )
      $pg_vars[substr($key,7)] = $val ;
  }
  reset ($HTTP_GET_VARS);
  while (list ($key, $val) = each ($HTTP_GET_VARS)) {
    if ( 'pg_var_' == substr($key, 0, 7) )
      $pg_vars[substr($key,7)] = $val ;
  }

  if( isset($pg_id) 
      && !isset($pg_vars['id']) )
  $pg_vars['id'] = $pg_id ;

  if( isset($vars['CONNECT'] ) )
    {
      # $pg_conn=pg_pconnect($vars["CONNECT"]);
      # ce_debug(30,"<!-- calling pg_conn(".preg_replace('/(password *= *)([^ ]*)/','\1 XXXXX',$vars["CONNECT"]).") -->\n",__FILE__,__LINE__);
      ce_debug(30,"<!-- calling pg_conn(".$vars["CONNECT"].") -->\n",__FILE__,__LINE__);
      $pg_conn=pg_connect($vars["CONNECT"]);
      if (!$pg_conn) {
        ce_error("pg_connect(".$vars["CONNECT"].") resulted in error.\n",__FILE__,__LINE__) ;
        return FALSE;
      }
    }
  else
    {
      $pg_conn=FALSE;
      $pg_user=$_SERVER["PHP_AUTH_USER"];
      $pg_password=$_SERVER["PHP_AUTH_PW"];
      if( isset($pg_user) 
          && isset($pg_password) )
        {
	  $connect_string="host='".$vars["HOST"]."'
                                port='".$vars["PORT"]."'
                                dbname='".$vars["DBNAME"]."'
                                user='".$pg_user."'
                                password='XXXX'";
          $prev_err_rep=error_reporting(E_ALL);
          ce_debug(30,"<!-- calling pg_conn(".$connect_string.") -->\n",__FILE__,__LINE__);
	  $connect_string="host='".$vars["HOST"]."'
                                port='".$vars["PORT"]."'
                                dbname='".$vars["DBNAME"]."'
                                user='".$pg_user."'
                                password='".$pg_password."'";
          $pg_conn=pg_connect($connect_string);
          error_reporting($prev_err_rep);
        }
      else
        $pg_conn=FALSE;
      if (!$pg_conn) {
	if( headers_sent() ) {
           print('<br>Sorry, there is a problem, maybe with authorization<br>');
           print('<br>Login: '.$_SERVER["PHP_AUTH_USER"].'<br>');
	} elseif( $ce_is_authenticated ) {
          ce_warn("Your are logged in to CruisEdit. This might clash with logging in to postgres",$item) ;
          print '<BR><A HREF="'.ce_prefix(TRUE).'/logoff.php?'.$_SERVER['PHP_AUTH_USER'].'">[logout]</A> from Cruisedit' ;
        } else {
        header('HTTP/1.0 401 Unauthorized');
        header('WWW-Authenticate: Basic realm=PG_'.$vars["HOST"].'_'.$vars["PORT"].'_'.$vars["DBNAME"]);
        }
        $ce_output_ok=TRUE;
?><HTML>
<BODY>
 <? // print pg_last_error(); ?><br>
</BODY>
</HTML><?
        return FALSE  ;
      }
      else
        { $ce_output_ok=TRUE;
          ce_debug(20,'<!-- pg_pconnect succeeded'."-->\n",__FILE__,__LINE__) ;
        }
    }

  $pg_query='; -- query unset';
  if( isset($vars["QUERY"]) )
    {
      $pg_query=$vars["QUERY"].";" ;
    }
  else
    {
      $my_path_info=str_replace($item->path,"",$HTTP_SERVER_VARS["PATH_INFO"]);
#       ce_debug(50,"\n<!-- \$my_path_info = ".$my_path_info." -->\n",
#                __FILE__,__LINE__);
      list($pg_table,$pg_cmd,$mode)=explode('/',$my_path_info,3);
      if( preg_match( '/[!"$%&\/\\()=;:.,\*+\'#]/' , $pg_table ) ) 
        { ce_error("Invalid character in table name",NULL,__FILE__,__LINE__) ; 
          return ;  }
      ce_debug(15,"\n<!-- from path '$my_path_info': table='$pg_table', pg_cmd='$pg_cmd', remainder='$remainder' -->\n") ;

      if( isset($vars['CMD']  )  )  $pg_cmd    = $vars['CMD']    ;
      if( isset($vars['MODE'] )  )  $mode      = $vars['MODE']   ;
      if( isset($vars['TABLE'])  )  $pg_table  = $vars['TABLE']  ;
      if( isset($vars['FIELDS']) )  $pg_fields = $vars['FIELDS'] ;

      if( "_" == $pg_cmd ) 
        {
          ce_debug(10,"\n<!-- checking foro submit button ...  -->\n") ;
          if(     ce_get_cgi_var("button_update")  ) $pg_cmd="update";
          elseif( ce_get_cgi_var("button_insert")  ) $pg_cmd="insert";
          elseif( ce_get_cgi_var("button_delete")  ) $pg_cmd="delete";
          ce_debug(10,"\n<!-- ... was button_".$pg_cmd."  -->\n") ;
        }

      # print 'pg_cmd = '.$pg_cmd.'<br>';
      # print 'mode = '.$mode.'<br>';
      # print 'pg_table = '.$pg_table.'<br>';
      # print 'pg_id = '.$pg_id.'<br>';

      ce_debug(10,"\n<!-- from path '$my_path_info': table='$pg_table', pg_cmd='$pg_cmd', remainder='$remainder' -->\n") ;

      if( 'select' ==  $pg_cmd )
        { return ce_mod_postgres_select($pg_conn,$pg_table,$pg_vars,$pg_fields,$pg_order_by); }
      else if( 'insert' ==  $pg_cmd )
        { return ce_mod_postgres_insert($pg_conn,$pg_table,$pg_vars); }
      else if( 'update' ==  $pg_cmd )
        { return ce_mod_postgres_update($pg_conn,$pg_table,$pg_vars); }
      else if( 'delete' ==  $pg_cmd )
        { return ce_mod_postgres_delete($pg_conn,$pg_table,$pg_vars); }
      else if( 'form' ==  $pg_cmd )
        { return ce_mod_postgres_form($pg_conn,$pg_table,$pg_id,$mode); }
      else if( 'login' ==  $pg_table )
        { if(! headers_sent() ) header('Location: '.$_SERVER['HTTP_REFERER'] );
          return ; }
      else 
        { header('HTTP/1.0 404 File not found');
          print $HTTP_SERVER_VARS["PATH_INFO"].' does not exist'; }
    }
}

#=======================================================================

function ce_mod_postgres_delete($pg_conn,$pg_table,$pg_vars)
{
  global $ce_user_vars;

  ce_debug(30,"<!-- ce_mod_postgres_delete($pg_conn,$pg_table,$pg_vars) called -->\n",__FILE__,__LINE__);

  $pg_url_return=ce_get_cgi_var('pg_url_return') ;

  $pg_id=$pg_vars['id'];
  unset($pg_vars['id']);

  if( !isset($pg_id) )
    {
      ce_error("No dataset id given",NULL,__FILE__,__LINE__) ;
      return ;
    }

  $pg_query='DELETE FROM '.$pg_table.' WHERE id = '.addslashes($pg_id);
  while (list ($key, $val) = each ($pg_vars) ) {
    if(!(empty($val)))
      $pg_query .= ' AND  '.addslashes($key)." = '".addslashes($val)."'";
  }
  $pg_query .= ' ;' ;
  $ce_user_vars['PG_QUERY']=$pg_query ;
  $pg_result=pg_query( $pg_conn , $pg_query) ;

  if(!$pg_result)
    {
      print("Ooops! That didn't work");
    }
  elseif(headers_sent())
    {
      print '<A HREF="'.$pg_url_return.'">proceed</A>';
      return;
    }
  else
   header('Location: '.$pg_url_return);
  print '<A HREF="'.$pg_url_return.'">proceed</A>';
}

#=======================================================================

function ce_mod_postgres_update($pg_conn,$pg_table,$pg_vars)
{
  global $ce_user_vars;

  ce_debug(30,"<!-- ce_mod_postgres_update($pg_conn,$pg_table,$pg_vars) called -->\n",__FILE__,__LINE__);

  $pg_url_return=ce_get_cgi_var('pg_url_return') ;

  $pg_id=$pg_vars['id'];
  unset($pg_vars['id']);

  if( !isset($pg_id) )
    {
      ce_error("No dataset id given",NULL,__FILE__,__LINE__) ;
      return ;
    }

  $settings=array();
  while (list ($key, $val) = each ($pg_vars) ) {
    array_push($settings,'"'.addslashes($key)."\" = '".addslashes($val)."'") ;
  }
  $pg_query='UPDATE '.$pg_table ;
  $pg_query .= ' SET '.implode($settings,' , ') ;
  $pg_query .= ' WHERE id = '.addslashes($pg_id).' ;' ;
  $ce_user_vars['PG_QUERY']=$pg_query ;

  $pg_result=pg_query( $pg_conn , $pg_query) ;

  if(!$pg_result)
    {
      print("Ooops! That didn't work");
    }
  elseif(headers_sent())
    {
      print '<A HREF="'.$pg_url_return.'">proceed</A>';
      return;
    }
  else
   header('Location: '.$pg_url_return);
  print '<A HREF="'.$pg_url_return.'">proceed</A>';
}

#=======================================================================

function ce_mod_postgres_insert($pg_conn,$pg_table,$pg_vars)
{
  global $ce_user_vars;

  ce_debug(30,"<!-- ce_mod_postgres_insert($pg_conn,$pg_table,$pg_vars) called -->\n",__FILE__,__LINE__);

  $pg_url_return=ce_get_cgi_var('pg_url_return') ;

  $pg_id=$pg_vars['id'];
  unset($pg_vars['id']);
  $fields=array();
  $values=array();
  while (list ($key, $val) = each ($pg_vars) ) {
    if( !empty($val) )
      {
        array_push($fields,'"'.addslashes($key).'"') ;
        array_push($values,"'".addslashes($val)."'") ;
      }
  }
  $pg_query='INSERT into '.$pg_table.' ';
  $pg_query .= '('.implode($fields,',').')' ;
  $pg_query .= ' VALUES ('.implode($values,',').');' ;
  $ce_user_vars['PG_QUERY']=$pg_query ;
  $pg_result=pg_query( $pg_conn , $pg_query) ;

  if(!$pg_result)
    {
      print("Ooops! That didn't work");
    }
  elseif(headers_sent())
    {
      print '<A HREF="'.$pg_url_return.'">proceed</A>';
      return;
    }
  else
   header('Location: '.$pg_url_return);
  print '<A HREF="'.$pg_url_return.'">proceed</A>';
}

#=======================================================================

function ce_mod_postgres_select($pg_conn,$pg_table,$pg_vars,$pg_fields,$pg_order_by)
{
  global $ce_user_vars;
  global $ce_mod;

  ce_debug(30,"<!-- ce_mod_postgres_select($pg_conn,$pg_table,$pg_vars,$pg_fields,$pg_order_by) called -->\n",__FILE__,__LINE__);

  $pg_window_edit=ce_get_cgi_var("pg_window_edit");
  $pg_window_show=ce_get_cgi_var("pg_window_show");
  $pg_window_this=ce_get_cgi_var("pg_window_this");

  $table_referenced = $ce_mod['postgres']['table_referenced'];

  ce_debug(20,'<!-- $pg_fields= "'.$pg_fields.'"'."-->\n",__FILE__,__LINE__) ;
  if( !empty($pg_fields) )
    {
      $out_fields=array('id');
      $in_fields=array();
      $in_fields=explode(',',$pg_fields);
      ce_debug(80,'<!-- $in_fields= "'.implode($in_fields,';').'"'."-->\n",__FILE__,__LINE__) ;
      while(list($k,$v)=each($in_fields) )
          array_push($out_fields,addslashes($v));
      ce_debug(80,'<!-- $out_fields= "'.implode($out_fields,';').'"'."-->\n",__FILE__,__LINE__) ;
      $sql_fields=implode($out_fields,',');
    }
  else
    {
      $sql_fields='*';
    }
  ce_debug(20,'<!-- $sql_fields= "'.$sql_fields.'"'."-->\n",__FILE__,__LINE__) ;

  # $pg_query="SELECT * FROM ".$pg_table." " ; 
  $pg_query="SELECT ".$sql_fields." FROM ".$pg_table." " ; 
  $url_var_str="";

  if(! empty($pg_vars) )
    {
      $conditions=array();
      $url_params=array();
      while (list ($key, $val) = each ($pg_vars) ) {
        array_push($conditions, addslashes($key)." = '".addslashes($val)."'");
        array_push($url_params, "pg_var_".urlencode($key)."=".urlencode($val) );
      }
      $pg_query.=' WHERE '.implode($conditions," AND ");
      $url_var_str.=implode($url_params,"&");
    }

  if(! empty($pg_order_by) )
    { $pg_query.=" ORDER BY ".$pg_order_by." ";  }

  $pg_query.=";"; 

  ce_debug(0,"<!-- QUERY: ".$pg_query." -->\n",__FILE__,__LINE__) ;

  $ce_user_vars['PG_QUERY']=$pg_query ;
  $pg_result=pg_query( $pg_conn , $pg_query ) ;

  if (!$pg_result) {
    ce_error('pg_query($pg_conn,"'.$pg_query.'".) resulted in error.'."\n",__FILE__,__LINE__) ;
    return FALSE;
  }

  print "<TABLE BORDER=1>\n";
  while( $arr = pg_fetch_array($pg_result) )
    {
      if(! $header_done )
        {
          print"<TR>";
          while (list($key, $value) = each($arr)) {
            if(is_string($key))
              {
                ?><TD><STRONG><?
                $heading=$key;
                ce_debug(1,'<!-- checking if $table_referenced['.$key.'] exists'."-->\n",
                         __FILE__,__LINE__) ;

                if( 'id' == $key )
                  {
                    $heading='';
                  }
                if( isset($table_referenced[$key]) )
                  {
                    $heading=preg_replace('/_id$/','',$key);

                    ce_debug(1,'<!-- $table_referenced['.$key.'] is '.$table_referenced[$key]."-->\n",
                             __FILE__,__LINE__) ;
                    ce_debug(1,'<!-- running pg_query($pg_conn,"'.$pg_query.'".).'."-->\n",
                             __FILE__,__LINE__) ;
                    $pg_sub_result=pg_query( $pg_conn ,'select id,name from "'
                                                       .addslashes($table_referenced[$key])
                                                       .'" ;' );
                    if (!$pg_result) {
                      ce_debug(1,'<!-- pg_query($pg_conn,"'.$pg_query.'".) resulted in error.'."-->\n",
                               __FILE__,__LINE__) ;
                      return FALSE;
                    }
                    while( $sub_arr = pg_fetch_array($pg_sub_result) ) {
                      $foreign_name[$table_referenced[$key]][$sub_arr['id']]=$sub_arr['name'];
                      ce_debug(10,'<!-- ce_mod_postgres_select: foreign name '
                                  .$sub_arr['name'].' for id '.$sub_arr['id'].''."-->\n",
                               __FILE__,__LINE__) ;                      
                    }

                    print '[<A HREF="javascript:void(0);" '
                      ."onclick=\"window.open('../".$table_referenced[$key]."/form/edit?"
                      .'pg_window_return='.urlencode($pg_window_this)
                      ."','CE_ItemEditWindow','left='+(screen.width/2-250)+',top='+(screen.height/2-250)+',width=500,height=500')\" "
                      ."TITLE=\"Add new ".$heading."\">create</A>]\n" ;

                  }
                else
                  {
                    ce_debug(1,'<!-- $table_referenced['.$key.'] not found.'."-->\n",
                             __FILE__,__LINE__) ;

                  }

                if( ( $pg_order_by == $key ) || ( 'id' == $key ) )
                  {
                    print '&nbsp;'.htmlentities($heading).'&nbsp;' ;
                  }
                else
                  {
                    print '<A HREF="select?pg_order_by='
                      .$key
                      .( isset($pg_fields)      ? '&pg_fields='.urlencode($pg_fields)           : '' )
                      .( isset($url_var_str)    ? '&'.($url_var_str)                            : '' )
                      .( isset($pg_window_edit) ? "&pg_window_edit=".urlencode($pg_window_edit) : '' )
                      .( isset($pg_window_show) ? "&pg_window_show=".urlencode($pg_window_show) : '' )
                      .( isset($pg_window_this) ? "&pg_window_this=".urlencode($pg_window_this) : '' )
                      .'" TITLE="sort by '.$key.'">'.$heading.'</A>' ;
                  }
                ce_debug(0,"<!-- value = '".$value."' -->\n",__FILE__,__LINE__) ;
                ?></STRONG></TD>
                <?
              }
          }
          print"</TR>\n";
          $header_done=TRUE;
        }
      reset($arr);
      print"<TR>";
      while (list($key, $value) = each($arr)) {
        if(is_string($key))
          {
            if( isset($table_referenced[$key])
                && isset($foreign_name[$table_referenced[$key]][$value]) )
              $table_value=$foreign_name[$table_referenced[$key]][$value];
            else
              $table_value=$value ;
            if( ( '_id' == substr($key,-3) )
                AND ( ! empty ($value) )  )
              {
                print '<TD><A HREF="../'.$table_referenced[$key]
                  .'/form/show?pg_id='.$value
                  .( isset($pg_window_show) ? '" TARGET="'.$pg_window_show : "" ).'">'.$table_value
                  .'</A>&nbsp;</TD>'."\n" ;
              }
            elseif( ( 'id' == $key )
                AND ( ! empty ($value) )  )
              {
                $table_value='change';
                print '<TD><A HREF="javascript:void(0);" '
                  ."onclick=\"(window.open('form/edit?pg_id=".urlencode($value)
                  .'&pg_window_return='.urlencode($pg_window_this)
                  ."','CE_ItemEditWindow','left='+(screen.width/2-250)+',top='+(screen.height/2-250)+',width=500,height=500')).focus();\" "
                  .'TITLE="Alter, clone or delete this rows data">'
                  .htmlentities($table_value).'</A>&nbsp;</TD>'."\n" ;
              }
            elseif( ( '_name' == substr($key,-5) )
                    AND ( ! empty ($arr[preg_replace('/_name/','_id',$key)]) )  )
              {
                print '<TD><A HREF="../'.$table_referenced[$key].'/form/show?pg_id='.$arr[preg_replace('/_name/','_id',$key)].'"'
                      .( isset($pg_window_show) ? '" TARGET="'.$pg_window_show : "" ).'>'.$table_value.'</A>&nbsp;</TD>'."\n" ;
              }
            elseif( ( 'name' == $key )
                AND ( ! empty ($arr['id']) )  )
              {
                print '<TD><A HREF="form/show?pg_id='.$arr['id'].'"'
                      .( isset($pg_window_show) ? '" TARGET="'.$pg_window_show : "" ).'">'.$table_value.'</A>&nbsp;</TD>'."\n" ;
              }
            else
              {
                print '<TD>'.$table_value.'&nbsp;</TD>'."\n" ;
              }
          }
        else
          {
            ce_debug(0,"<!-- skipping key $key -->",__FILE__,__LINE__) ;
          }
      }
      print "</TR>\n";
    }
  
  $query_strings=array();
  if(isset($pg_vars))
    {
      reset($pg_vars);
      while (list ($key, $val) = each ($pg_vars) ) {
        array_push($query_strings, 'pg_var_'.urlencode($key)."=".urlencode($val) );
      }
      $query_string=implode($query_strings,'&');
    }
  print'</TABLE>';
  print '<A HREF=javascript:void(0) '
    ."onclick=\"(window.open('form/edit?"
    .'pg_window_return='.urlencode($pg_window_this)
    .'&'.$query_string
    ."','CE_ItemEditWindow','left='+(screen.width/2-250)+',top='+(screen.height/2-250)+',width=500,height=500')).focus()\" >create row</A>\n" ;

}

#---------------------------------------------------------------------------------------------------------------------------------------------------------

function ce_mod_postgres_form($pg_conn,$pg_table,$pg_id,$mode)
{
  global $ce_user_vars;
  global $ce_mod;

  ce_debug(30,"<!-- ce_mod_postgres_form($pg_conn,$pg_table,$pg_id,$mode) called -->\n",__FILE__,__LINE__);


  $immutable        = $ce_mod['postgres']['immutable'];
  $table_referenced = $ce_mod['postgres']['table_referenced'];

  $pg_window_return=ce_get_cgi_var("pg_window_return");

  if( ( "show" == $mode)
      && !isset($pg_id) )
    {
      ce_error("No dataset id given",NULL,__FILE__,__LINE__) ;
      return ;
    }

  if( isset($pg_id) )
    $pg_query="SELECT * FROM ".$pg_table." WHERE id = ".addslashes($pg_id)." ;";
  else
    $pg_query="SELECT * FROM ".$pg_table." LIMIT 1 ;";

  ce_debug(0,"<!-- QUERY: ".$pg_query." -->\n");

  $ce_user_vars['PG_QUERY']=$pg_query ;
  $ce_user_vars['PG_ID']=$pg_id ;
  $pg_result=pg_query( $pg_conn , $pg_query ) ;

  if(!isset($pg_url_return) )
    $pg_url_return=$_SERVER['HTTP_REFERER'];

  if( "edit" == $mode )
    {
      print '<FORM METHOD="POST" 
                   ACTION="../_" '
        .( isset($pg_window_return) ? 'TARGET="'.$pg_window_return.'"' : "").'>
             <INPUT TYPE="hidden" 
                    NAME="pg_id" 
                    VALUE="'.htmlentities($pg_id).'">
             <INPUT TYPE="hidden" 
                    NAME="pg_url_return" 
                    VALUE="'.htmlentities($pg_url_return).'">';
    }
  print "<TABLE BORDER=1>\n";
  if( isset($pg_id) )
    $arr = pg_fetch_array($pg_result) ;
  else
    {
      $num = pg_num_fields($pg_result) ;
      $arr=array();
      for ($j = 0; $j < $num; $j++) {
        $arr[pg_field_name($pg_result, $j)]=NULL;
      }
    }
  if( $arr )
    {
      while (list($key, $value) = each($arr)) {
        if(is_string($key))
          {
            if(!isset($pg_id)) $value=ce_get_cgi_var('pg_var_'.$key) ;
            ce_debug(60,'<!-- $value is "'.$value.'"-->'."\n",
              __FILE__,__LINE__);
            $table_value=$value;
            if( isset($table_referenced[$key]) )
              {
                ce_debug(20,'<!-- $table_referenced['.$key.'] is '.$table_referenced[$key]."-->\n",
                         __FILE__,__LINE__) ;
                ce_debug(10,'<!-- running pg_query($pg_conn,"'.$pg_query.'".).'."-->\n",
                         __FILE__,__LINE__) ;
                $pg_sub_result=pg_query( $pg_conn ,'select id,name from "'
                                         .addslashes($table_referenced[$key])
                                         .'" ORDER BY name ;' );
                if (!$pg_result) {
                  ce_debug(1,'<!-- pg_query($pg_conn,"'.$pg_query.'".) resulted in error.'."-->\n",
                           __FILE__,__LINE__) ;
                  return FALSE;
                }
                while( $sub_arr = pg_fetch_array($pg_sub_result) ) {
                  $foreign_name[$table_referenced[$key]][$sub_arr['id']]=$sub_arr['name'];
                  ce_debug(90,'<!-- ce_mod_postgres_select: foreign name '
                           .$sub_arr['name'].' for id '.$sub_arr['id'].''."-->\n",
                           __FILE__,__LINE__) ;                      
                }
                $table_value=$foreign_name[$table_referenced[$key]][$value];
              }
            ce_debug(60,'<!-- $table_value is "'.$table_value.'"-->'."\n",
                     __FILE__,__LINE__);

            if( !isset($immutable[$key]) )
              {
                print '<TR><TD><STRONG>'.$key."</STRONG></TD>\n<TD>";
                if ( ( "edit" == $mode ) && ( !isset($immutable[$key] ) ) )
                  if( isset($table_referenced[$key]) )
                    {
                      print '<SELECT NAME="pg_var_'.$key.'">';
                      if( empty($value) )
                        print '<OPTION VALUE="" SELECTED> - select '.$key.' - &nbsp;</OPTION>'."\n";
                      while( list($k,$v)=each($foreign_name[$table_referenced[$key]]) )
                        print '<OPTION VALUE="'.htmlentities($k).'" '
                          .( ($k == $value) ? "SELECTED" : "")
                          .'>'.htmlentities($v).'&nbsp;</OPTION>'."\n";
                      print '</SELECT>';
                    }
                  else
                    print '<INPUT TYPE="TEXT" NAME="pg_var_'.$key.'" VALUE="'.htmlentities($table_value).'">&nbsp;' ;
                else
                  if( isset($table_referenced[$key]) && isset($value) )
                    {
                      print '<A HREF="../../'.$table_referenced[$key].'/form/show?pg_id='.$value.'">'.htmlentities($table_value).'&nbsp;'.'</A>';

                    }
                  else
                    print htmlentities($table_value).'&nbsp;';
                print "</TD></TR>\n" ;
              }
          }
      }
    }
  print'</TABLE>'."\n";
  if( "edit" == $mode )
    {
      if(isset($pg_id))
        print '<INPUT TYPE="SUBMIT" VALUE="Apply Changes"       NAME="button_update" '.( isset($pg_window_return) ? 'onclick=window.close()' : 'onclick=self.back()' ).'>'."\n";
      print '<INPUT TYPE="SUBMIT" VALUE="Insert as new"  NAME="button_insert"  '.( isset($pg_window_return) ? 'onclick=window.close()' : 'onclick=self.back()' ).'>'."\n";
      print '<INPUT TYPE="RESET"  VALUE="Cancel"  NAME="button_cancel" '.( isset($pg_window_return) ? 'onclick=window.close()' : 'onclick=self.back()' ).'>'."\n";
      if(isset($pg_id))
        print '<INPUT TYPE="SUBMIT"  VALUE="Delete"  NAME="button_delete" '.( isset($pg_window_return) ? 'onclick=window.close()' : '' ).'>'."\n";
      print '</FORM>'."\n";
    }
  else                  print '<A HREF="edit?pg_id='.$pg_id.'">edit</A>'."\n";

}


?>
